﻿using System;
using System.Collections.Generic;
using DistributedGA.Core.Domain;
using DistributedGA.Core.Util;

namespace DistributedGA.Core.Interface {

  public interface IMessageHandler {

    void Init(string lanIpPrefix, string contactServerUrl, string problemInstance, int messageCacheCapacty, double communicationRate);

    void PublishDataToNetwork(ByteArrayWrapper data);

    List<KeyValuePair<PeerInfo, ByteArrayWrapper>> GetDataFromNetwork();

    PeerInfo GetPeerInfo();

    List<PeerInfo> GetCurrentNetwork();

    void Dispose();

    event EventHandler<Exception> ExceptionOccurend;
  }
}
